#include "stdafx.h"
#include "R-DT-EVO-UHF-USB-SDK-DEMO.h"
#include "DlgGenericInfo.h"

#include "R-DT-EVO-UHF-USB-SDK.h"
#include "Utility.h"
#include "Def.h"


IMPLEMENT_DYNAMIC(CDlgGenericInfo, CPropertyPage)

CDlgGenericInfo::CDlgGenericInfo()
	: CPropertyPage(CDlgGenericInfo::IDD)
{

}

CDlgGenericInfo::~CDlgGenericInfo()
{
}

void CDlgGenericInfo::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_SERIAL_NUMBER, m_ctrlSerialNr);
	DDX_Control(pDX, IDC_COMBO_COM, m_ctrlCom);
	DDX_Control(pDX, IDC_EDIT_READER_TYPE, m_ctrlReaderType);
	DDX_Control(pDX, IDC_EDIT_HARDWARE_REV, m_ctrlHardwareRev);
	DDX_Control(pDX, IDC_EDIT_SOFTWARE_REV, m_ctrlSoftwareRev);
	DDX_Control(pDX, IDC_EDIT_BOOT_REV, m_ctrlBootRev);
	DDX_Control(pDX, IDC_EDIT_CURRENT_STATE, m_ctrlCurrentState);
	DDX_Control(pDX, IDC_EDIT_ATTENUATION_MAX, m_ctrlAttenuation);
	DDX_Control(pDX, IDC_SPIN_ATTENUATION, m_ctrlSpinAttenuation);
	DDX_Control(pDX, IDC_EDIT_SENSIVITY, m_ctrlSensitivity);
	DDX_Control(pDX, IDC_SPIN_SENSIVITY, m_ctrlSpinSensitivity);
	DDX_Control(pDX, IDC_COMBO_FREQUENCY, m_ctrlFreq);
}


BEGIN_MESSAGE_MAP(CDlgGenericInfo, CPropertyPage)
	ON_BN_CLICKED(IDC_BUTTON_GET_INFO, &CDlgGenericInfo::OnBnClickedButtonGetInfo)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_ATTENUATION, &CDlgGenericInfo::OnDeltaposSpinAttenuation)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_SENSIVITY, &CDlgGenericInfo::OnDeltaposSpinSensivity)
	ON_BN_CLICKED(IDC_BUTTON_REBOOT, &CDlgGenericInfo::OnBnClickedButtonReboot)
	ON_BN_CLICKED(IDC_BUTTON_ATTENUATION, &CDlgGenericInfo::OnBnClickedButtonAttenuation)
	ON_BN_CLICKED(IDC_BUTTON_SENSIVITY, &CDlgGenericInfo::OnBnClickedButtonSensivity)
	ON_BN_CLICKED(IDC_BUTTON_FREQUENCY, &CDlgGenericInfo::OnBnClickedButtonFrequency)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_SETTINGS, &CDlgGenericInfo::OnBnClickedButtonSaveSettings)
	ON_BN_CLICKED(IDC_BUTTON_RESTORE_SETTINGS, &CDlgGenericInfo::OnBnClickedButtonRestoreSettings)
END_MESSAGE_MAP()

// I do this because I should optimize refresh 
void CDlgGenericInfo::InsertCom(UINT nCom)
{
	m_vctCom.push_back(nCom);
}

BOOL CDlgGenericInfo::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	CString strDisp = _T("");

	std::vector<UINT>::iterator it = m_vctCom.begin();
	while(it != m_vctCom.end())
	{
		strDisp.Format(_T("COM%d"), *it);
		m_ctrlCom.SetItemData(m_ctrlCom.AddString(strDisp), *it);
		it++;
	}

	m_ctrlCom.SetCurSel(0);

	return TRUE;
}

void CDlgGenericInfo::OnBnClickedButtonGetInfo()
{
	if(m_ctrlCom.GetCurSel() != LB_ERR)
	{
		SDKHANDLE hSdk = NULL;
		if((hSdk = OpenReader((UINT)m_ctrlCom.GetItemData(m_ctrlCom.GetCurSel()))) != NULL)
		{
			CString strTmp = _T("");
			BYTE pData[MAX_PATH]; DWORD dwSize = MAX_PATH;
			DATA_STRUCT* pDataStruct = (DATA_STRUCT*)pData;

			ZeroMemory(pData, MAX_PATH);
			if(GetReaderCaps(hSdk, ERD_SERIAL_NUMER, pData, dwSize) == ER_OK)
			{
				USES_CONVERSION;
				m_ctrlSerialNr.SetWindowText(CUtility::DataToString(pData, dwSize));
			}

			
			ZeroMemory(pData, MAX_PATH); dwSize = MAX_PATH;
			if(GetReaderCaps(hSdk, ERD_READER_TYPE, pData, dwSize) == ER_OK)
			{
				USES_CONVERSION;
				m_ctrlReaderType.SetWindowText(CUtility::DataToString(pData, dwSize));
			}

			ZeroMemory(pData, MAX_PATH); dwSize = MAX_PATH;
			if(GetReaderCaps(hSdk, ERD_HARDWARE_REV, pData, dwSize) == ER_OK)
			{
				USES_CONVERSION;
				m_ctrlHardwareRev.SetWindowText(CUtility::DataToString(pData, dwSize));
			}

			ZeroMemory(pData, MAX_PATH); dwSize = MAX_PATH;
			if(GetReaderCaps(hSdk, ERD_SOFTWARE_REV, pData, dwSize) == ER_OK)
			{
				USES_CONVERSION;
				m_ctrlSoftwareRev.SetWindowText(CUtility::DataToString(pData, dwSize));
			}

			ZeroMemory(pData, MAX_PATH); dwSize = MAX_PATH;
			if(GetReaderCaps(hSdk, ERD_BOOTLOADER_REV, pData, dwSize) == ER_OK)
			{
				USES_CONVERSION;
				m_ctrlBootRev.SetWindowText(CUtility::DataToString(pData, dwSize));
			}

			ZeroMemory(pData, MAX_PATH); dwSize = MAX_PATH;
			if(GetReaderCaps(hSdk, ERD_CURRENT_STATE, pData, dwSize) == ER_OK)
			{
				switch(pData[0x00])
				{
					case 0x00: m_ctrlCurrentState.SetWindowText(_T("Idle")); break;
					default: m_ctrlCurrentState.SetWindowText(_T("Unknown")); break;
				}
			}

			ZeroMemory(pData, MAX_PATH); dwSize = MAX_PATH;
			if(GetReaderCaps(hSdk, ERD_ATTENUATION, pData, dwSize) == ER_OK)
			{
				strTmp.Format(_T("%d"), pDataStruct->stAttenuation.shAttenuation);
				m_ctrlAttenuation.SetWindowText(strTmp);

				m_ctrlSpinAttenuation.SetRange(0, pDataStruct->stAttenuation.shMaxAttenuation);
				m_ctrlSpinAttenuation.SetPos(pDataStruct->stAttenuation.shAttenuation);
			}

			ZeroMemory(pData, MAX_PATH); dwSize = MAX_PATH;
			if(GetReaderCaps(hSdk, ERD_SENSITIVITY, pData, dwSize) == ER_OK)
			{
				strTmp.Format(_T("%d"), pDataStruct->stSensitivity.shSensitivity);
				m_ctrlSensitivity.SetWindowText(strTmp);

				m_ctrlSpinSensitivity.SetRange(pDataStruct->stSensitivity.shMinSensitivity, pDataStruct->stSensitivity.shMaxSensitivity);
				m_ctrlSpinSensitivity.SetPos(pDataStruct->stSensitivity.shSensitivity);
			}

			ZeroMemory(pData, MAX_PATH); dwSize = MAX_PATH;
			if(GetReaderCaps(hSdk, ERD_FREQUENCY, pData, dwSize) == ER_OK)
			{
				for(UINT nCount = 0; nCount < pData[0x00]; nCount++)
				{
					strTmp.Format(_T("%d"), pDataStruct->stFrequency.lFreq[nCount]);
					m_ctrlFreq.SetItemData(m_ctrlFreq.AddString(strTmp), pDataStruct->stFrequency.lFreq[nCount]);
				}
				m_ctrlFreq.SetCurSel(0);
			}

			CloseReader(hSdk);
		}
	}	
}

void CDlgGenericInfo::OnBnClickedButtonReboot()
{
	if(m_ctrlCom.GetCurSel() != LB_ERR)
	{
		SDKHANDLE hSdk = NULL;
		if((hSdk = OpenReader((UINT)m_ctrlCom.GetItemData(m_ctrlCom.GetCurSel()))) != NULL)
		{
			BYTE bReboot = 0x01;
			if(SetReaderCaps(hSdk, ERD_REBOOT, &bReboot, 0x01) == ER_OK)
			{
				TRACE("Reboot done !!! \r\n");
			}
			CloseReader(hSdk);
		}
	}
}

void CDlgGenericInfo::OnBnClickedButtonAttenuation()
{
	if(m_ctrlCom.GetCurSel() != LB_ERR)
	{
		SDKHANDLE hSdk = NULL;
		if((hSdk = OpenReader((UINT)m_ctrlCom.GetItemData(m_ctrlCom.GetCurSel()))) != NULL)
		{
			short shAttn = (short)m_ctrlSpinAttenuation.GetPos();
			if(SetReaderCaps(hSdk, ERD_ATTENUATION, (BYTE*)&shAttn, sizeof(short)) == ER_OK)
			{
				TRACE("Set attenuation done !!! \r\n");
			}
			CloseReader(hSdk);
		}
	}
}

void CDlgGenericInfo::OnBnClickedButtonSensivity()
{
	if(m_ctrlCom.GetCurSel() != LB_ERR)
	{
		SDKHANDLE hSdk = NULL;
		if((hSdk = OpenReader((UINT)m_ctrlCom.GetItemData(m_ctrlCom.GetCurSel()))) != NULL)
		{
			short shSens = (short)m_ctrlSpinSensitivity.GetPos();
			if(SetReaderCaps(hSdk, ERD_SENSITIVITY, (BYTE*)&shSens, sizeof(short)) == ER_OK)
			{
				TRACE("Set sensivity done !!! \r\n");
			}
			CloseReader(hSdk);
		}
	}
}

void CDlgGenericInfo::OnBnClickedButtonFrequency()
{
	if(m_ctrlCom.GetCurSel() != LB_ERR)
	{
		SDKHANDLE hSdk = NULL;
		if((hSdk = OpenReader((UINT)m_ctrlCom.GetItemData(m_ctrlCom.GetCurSel()))) != NULL)
		{
			BYTE pData[MAX_PATH]; DWORD dwSize = 0x00;
			DATA_STRUCT* pStData = (DATA_STRUCT*)pData;

			pStData->stFrequency.bNrFreq = (BYTE)m_ctrlFreq.GetCount();
			for(UINT nCount = 0; nCount < pStData->stFrequency.bNrFreq; nCount++)
			{
				pStData->stFrequency.lFreq[nCount] = m_ctrlFreq.GetItemData(nCount);
			}

			dwSize = pStData->stFrequency.bNrFreq * sizeof(ULONG) + sizeof(BYTE);
			if(SetReaderCaps(hSdk, ERD_FREQUENCY, pData, dwSize) == ER_OK)
			{
				TRACE("Set frequency done !!! \r\n");
			}
			CloseReader(hSdk);
		}
	}
}

void CDlgGenericInfo::OnBnClickedButtonRestoreSettings()
{
	if(m_ctrlCom.GetCurSel() != LB_ERR)
	{
		SDKHANDLE hSdk = NULL;
		if((hSdk = OpenReader((UINT)m_ctrlCom.GetItemData(m_ctrlCom.GetCurSel()))) != NULL)
		{
			BYTE bSaveSettings = 0x01;
			if(SetReaderCaps(hSdk, ERD_RESTORE_SETTINGS, (BYTE*)&bSaveSettings, sizeof(BYTE)) == ER_OK)
			{
				TRACE("Set restore settings done !!! \r\n");
			}
			CloseReader(hSdk);
		}
	}
}

void CDlgGenericInfo::OnBnClickedButtonSaveSettings()
{
	if(m_ctrlCom.GetCurSel() != LB_ERR)
	{
		SDKHANDLE hSdk = NULL;
		if((hSdk = OpenReader((UINT)m_ctrlCom.GetItemData(m_ctrlCom.GetCurSel()))) != NULL)
		{
			BYTE bSaveSettings = 0x01;
			if(SetReaderCaps(hSdk, ERD_SAVE_SETTINGS, (BYTE*)&bSaveSettings, sizeof(BYTE)) == ER_OK)
			{
				TRACE("Set save settings done !!! \r\n");
			}
			CloseReader(hSdk);
		}
	}
}

void CDlgGenericInfo::OnDeltaposSpinAttenuation(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	CString strDisplay = _T("");
	SHORT shData = m_ctrlSpinAttenuation.GetPos();
	strDisplay.Format(_T("%d"),shData);
	m_ctrlAttenuation.SetWindowText(strDisplay);

	*pResult = 0;
}

void CDlgGenericInfo::OnDeltaposSpinSensivity(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	CString strDisplay = _T("");
	SHORT shData = m_ctrlSpinSensitivity.GetPos();
	strDisplay.Format(_T("%d"),shData);
	m_ctrlSensitivity.SetWindowText(strDisplay);

	*pResult = 0;
}


